package com.hongyegroup.cpt_main.ui

import android.os.Bundle
import com.guadou.cs_cptservices.YYConstants
import com.guadou.cs_cptservices.base.fragment.YYBaseVDBFragment
import com.guadou.cs_cptservices.interfaces.IFragmentRefresh
import com.guadou.cs_router.YYRouterService
import com.guadou.lib_baselib.bean.DataBindingConfig
import com.guadou.lib_baselib.utils.CommUtils
import com.hongyegroup.cpt_main.BR
import com.hongyegroup.cpt_main.R
import com.hongyegroup.cpt_main.databinding.FragmentProfileBinding
import com.hongyegroup.cpt_main.mvvm.ProfileViewModel
import com.hongyegroup.cpt_main.widget.AccountDeactivationDialog
import com.hongyegroup.cpt_main.widget.UserUrgentAlertPopup
import com.lxj.xpopup.XPopup
import com.scwang.smart.refresh.layout.api.RefreshLayout
import com.scwang.smart.refresh.layout.listener.OnRefreshListener

/**
 * 首页列表
 */
class ProfileFragment : YYBaseVDBFragment<ProfileViewModel, FragmentProfileBinding>(), IFragmentRefresh,
    OnRefreshListener {

    override fun getDataBindingConfig(): DataBindingConfig {
        return DataBindingConfig(R.layout.fragment_profile, BR.viewModel, mViewModel)
            .addBindingParams(BR.click, ClickProxy())
    }

    override fun startObserve() {
    }

    override fun init(savedInstanceState: Bundle?) {

        initView()
        initData()
        initListener()
    }

    private fun initView() {


    }

    private fun initData() {
        showStateLoading()
        CommUtils.getHandler().postDelayed({
            showStateSuccess()
        }, 1500)
    }

    private fun initListener() {

    }

    override fun onRefresh(refreshLayout: RefreshLayout) {

    }

    override fun scrollTopRefresh() {

    }

    /**
     * DataBinding事件处理
     */
    inner class ClickProxy {

        //跳转到邀请朋友界面
        fun gotoInviteFriendsActivity() {

            InviteFriendsActivity.startInstance()

        }

        //跳转到Settings界面
        fun gotoSettingsActivity() {

            SettingsActivity.startInstance()

        }

        //编辑个人信息
        fun editProfileInfo() {

            YYRouterService.parttimeComponentServer?.startPartTimeJobEditProfileInfoActivity()

        }

        //审核状态加急
        fun userUrgent() {

            //弹窗展示以及申请成功
            XPopup.Builder(mActivity)
                .hasShadowBg(true)
                .asCustom(UserUrgentAlertPopup(mActivity))
                .show()

        }

        //跳转到个人信息界面
        fun gotoProfileInfoActivity() {

            ProfileInfoActivity.startInstance()

        }

        //编辑用户信息
        fun editUserInfo() {

            EditUserInfoActivity.startInstance()

        }

        //注销账号
        fun userDeactivationAccount() {

            val accountDeactivationDialog = AccountDeactivationDialog()

            accountDeactivationDialog.setOnAccountDeactivationDialogListener(object : AccountDeactivationDialog.OnAccountDeactivationDialogClickListener {
                override fun onClickYes() {

                    //                    mPresenter.accountDeactivation();

                    AccountDeactivationActivity.startInstance()

                }

            })
            accountDeactivationDialog.show(childFragmentManager, "account_deactivation")

        }

        //跳转到News Feed
        fun gotoNewsFeed(){

            YYRouterService.newsfeedComponentServer?.startNewsFeedHomePage()

        }

        //跳转到Help Center
        fun gotoHelpCenter(){

            HelpCenterProfileH5Activity.startInstance(YYConstants.HELP_CENTER_URL)

        }

    }


}