package com.hongyegroup.cpt_main.ui

import android.content.Intent
import android.os.Bundle
import com.guadou.cs_cptservices.YYConstants
import com.guadou.cs_cptservices.base.activity.YYBaseVDBActivity
import com.guadou.cs_cptservices.ui.GlobalWebActivity
import com.guadou.lib_baselib.base.vm.BaseViewModel
import com.guadou.lib_baselib.bean.DataBindingConfig
import com.guadou.lib_baselib.utils.CommUtils
import com.guadou.lib_baselib.utils.SPUtils
import com.hongyegroup.cpt_main.BR
import com.hongyegroup.cpt_main.R
import com.hongyegroup.cpt_main.databinding.ActivitySettingsBinding

class SettingsActivity : YYBaseVDBActivity<BaseViewModel, ActivitySettingsBinding>() {

    val mClickProxy by lazy { ClickProxy() }

    companion object {
        fun startInstance() {
            val context = CommUtils.getContext()
            val intent = Intent(context, SettingsActivity::class.java)
            intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
            context.startActivity(intent)
        }
    }

    override fun init(savedInstanceState: Bundle?) {


    }

    override fun getDataBindingConfig(): DataBindingConfig {

        return DataBindingConfig(R.layout.activity_settings, BR.viewModel, mViewModel)
            .addBindingParams(BR.click, mClickProxy)

    }

    override fun startObserve() {

    }

    /**
     * DataBinding事件处理
     */
    inner class ClickProxy {

        //点击重置密码
        fun resetPassword() {

//            ResetPasswordActivity.startInstance()

        }

        //点击常见问题
        fun gotoQAActivity() {

            var tokenStr = SPUtils.getInstance(CommUtils.getContext()).getString(YYConstants.USER_TOKEN, "")
            var webUrl = YYConstants.PART_TIME_QA_URL + "?token=" + tokenStr
            GlobalWebActivity.startInstance("常见问题", webUrl)

        }

    }

}