package com.hongyegroup.cpt_rewards.widget;

import android.annotation.SuppressLint;
import android.content.Context;
import android.text.TextUtils;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.guadou.cs_cptservices.YYConstants;
import com.guadou.cs_cptservices.widget.RangeBarView;
import com.guadou.lib_baselib.utils.CommUtils;
import com.guadou.lib_baselib.utils.SPUtils;
import com.hongyegroup.cpt_rewards.R;
import com.lxj.xpopup.core.AttachPopupView;
import com.lxj.xpopup.impl.PartShadowPopupView;
import com.lxj.xpopup.util.XPopupUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;

import androidx.annotation.NonNull;

public class RewardsSortByXPopup extends PartShadowPopupView {

    private LinearLayout mLastLl;
    private TextView mLastTv;
    private ImageView mLastChooseIv;
    private LinearLayout mPopularityLl;
    private TextView mPopularityTv;
    private ImageView mPopularityChooseIv;
    private LinearLayout mLowLl;
    private TextView mLowTv;
    private ImageView mLowChooseIv;
    private LinearLayout mHighLl;
    private TextView mHighTv;
    private ImageView mHighChooseIv;
    private TextView mPointFilterTv;
    private RangeBarView mRangeBarView;
    private ImageView mRewardsTipIv;
    private LinearLayout mRewardsTipLl;
    private TextView mApplyTv;

    public String mSortById;
    public String mSortId;
    public int mAvailablePoints = 0;
    private final int minValue = 0;
    private final int maxValue = 100000;
    private final int sliceValue = 3000;
    private int mStartPoint;
    private int mEndPoint;
    private boolean isAgree = false;

    private List<TextView> mTextList = new ArrayList<>();
    private List<ImageView> mImageViewList = new ArrayList<>();

    private OnClickRewardsSortByXPopupListener mListener;

    public RewardsSortByXPopup(@NonNull Context context, /*String sortById, String sortId, int startPoint, int endPoint, */OnClickRewardsSortByXPopupListener listener) {
        super(context);

//        mSortById = sortById;
//        mSortId = sortId;
//        mStartPoint = startPoint;
//        mEndPoint = endPoint;

        if (listener != null) {

            mListener = listener;

        }

    }

    @Override
    protected int getImplLayoutId() {
        return R.layout.view_rewards_sort_by;
    }

    @Override
    protected void onCreate() {
        super.onCreate();
    }

    @Override
    protected int getPopupWidth() {
        return XPopupUtils.getWindowWidth(getContext());
    }

    @Override
    protected void initPopupContent() {
        super.initPopupContent();

        mAvailablePoints = SPUtils.getInstance(CommUtils.getContext()).getInt(YYConstants.CACHE_REWARDS_POINTS, 0);

        initView();
        initListener();

    }

    @SuppressLint("CheckResult")
    private void initListener() {

        mRangeBarView.setDatas(minValue, maxValue, sliceValue, new RangeBarView.OnMoveValueListener() {
            @Override
            public void onMoveValue(int leftValue, int rightValue) {
//                mPointFilterTv.setText(leftValue + CommUtils.getString(R.string.points) + " -" + " " + rightValue + " " + CommUtils.getString(R.string.points));
                mPointFilterTv.setText(leftValue + "积分" + " -" + " " + rightValue + " " + "积分");
                mStartPoint = leftValue;
                mEndPoint = rightValue;
            }

            @Override
            public void noCheckBox() {
                isAgree = false;
                mRewardsTipIv.setImageResource(R.drawable.filter_unchoose);
            }
        });

        mRangeBarView.post(() -> {
            //只要传递过来的区间左右有一个不为0就去设置上次选中的区间
            if (mStartPoint != 0 || mEndPoint != 0) {
                mRangeBarView.setCircleMoveCoordinateByValue(mStartPoint, mEndPoint);
//                mPointFilterTv.setText(mStartPoint + CommUtils.getString(R.string.points) + " -" + " " + mEndPoint + " " + CommUtils.getString(R.string.points));
                mPointFilterTv.setText(mStartPoint + "积分" + " -" + " " + mEndPoint + " " + "积分");
            }
        });


        mApplyTv.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {

                if (mListener != null) {

                    mListener.onClickApply(mSortById, mSortId, mStartPoint, mEndPoint);

                }

                dismiss();


            }
        });

        mRewardsTipLl.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {

                if (isAgree) {
                    isAgree = false;
                    mRangeBarView.setCircleMoveCoordinateByValue(0, maxValue);
                    mStartPoint = 0;
                    mEndPoint = maxValue;
                } else {
                    isAgree = true;
                    mRangeBarView.setCircleMoveCoordinateByValue(0, mAvailablePoints == 0 ? 3000 : mAvailablePoints);
                    mStartPoint = 0;
                    mEndPoint = mAvailablePoints == 0 ? 3000 : mAvailablePoints;
                }
                mRewardsTipIv.setImageResource(isAgree ? R.drawable.filter_choose : R.drawable.filter_unchoose);
//            mPointFilterTv.setText(mStartPoint + CommUtils.getString(R.string.points) + " -" + " " + mEndPoint + " " + CommUtils.getString(R.string.points));
                mPointFilterTv.setText(mStartPoint + "积分" + " -" + " " + mEndPoint + " " +"积分");

            }
        });

        mLastLl.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {

                selectSortBy(0);
                mSortById = "4";
                mSortId = "";

            }
        });

        mPopularityLl.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {

                selectSortBy(1);
                mSortById = "1";
                mSortId = "";

            }
        });

        mLowLl.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {

                selectSortBy(2);
                mSortById = "";
                mSortId = "1";

            }
        });

        mHighLl.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {

                selectSortBy(3);
                mSortById = "";
                mSortId = "2";

            }
        });


    }

    //设置选中的Sort By
    private void selectSortBy(int position) {

        for (int index = 0; index < 4; index++) {

            if (index == position) {

                mTextList.get(index).setTextColor(CommUtils.getColor(R.color.profile_red));
                mImageViewList.get(index).setVisibility(VISIBLE);

            } else {

                mTextList.get(index).setTextColor(CommUtils.getColor(R.color.black));
                mImageViewList.get(index).setVisibility(GONE);

            }

        }

    }

    private void initView() {

        mLastLl = findViewById(R.id.ll_latest_box);
        mLastTv = findViewById(R.id.tv_rewards_sort_by_last);
        mLastChooseIv = findViewById(R.id.iv_latest_choose);

        mPopularityLl = findViewById(R.id.ll_popularity_box);
        mPopularityTv = findViewById(R.id.tv_rewards_sort_by_popularity);
        mPopularityChooseIv = findViewById(R.id.iv_popularity_choose);

        mLowLl = findViewById(R.id.ll_low_box);
        mLowTv = findViewById(R.id.tv_rewards_sort_by_low);
        mLowChooseIv = findViewById(R.id.iv_low_choose);

        mHighLl = findViewById(R.id.ll_high_box);
        mHighTv = findViewById(R.id.tv_rewards_sort_by_high);
        mHighChooseIv = findViewById(R.id.iv_high_choose);

        mPointFilterTv = findViewById(R.id.tv_points_filter_text);
        mRangeBarView = findViewById(R.id.view_range_bar);
        mRewardsTipIv = findViewById(R.id.iv_rewards_tip);
        mRewardsTipLl = findViewById(R.id.ll_rewards_tip);
        mApplyTv = findViewById(R.id.button_apply);

        mTextList.clear();
        mTextList.add(mLastTv);
        mTextList.add(mPopularityTv);
        mTextList.add(mLowTv);
        mTextList.add(mHighTv);

        mImageViewList.clear();
        mImageViewList.add(mLastChooseIv);
        mImageViewList.add(mPopularityChooseIv);
        mImageViewList.add(mLowChooseIv);
        mImageViewList.add(mHighChooseIv);

        //设置Poin区间
//        mPointFilterTv.setText(minValue + CommUtils.getString(R.string.points) + " -" + " " + maxValue + " " + CommUtils.getString(R.string.points));
        mPointFilterTv.setText(minValue + "积分" + " -" + " " + maxValue + " " + "积分");

        //设置Sort By
        if (!TextUtils.isEmpty(mSortById)) {

            if (mSortById.equals("4")) {

                selectSortBy(0);
            } else if (mSortById.equals("1")) {

                selectSortBy(1);
            }

        }

        //设置Sort
        if (!TextUtils.isEmpty(mSortId)) {

            if (mSortId.equals("1")) {

                selectSortBy(2);

            } else if (mSortId.equals("2")) {

                selectSortBy(3);

            }

        }

    }

    public interface OnClickRewardsSortByXPopupListener {

        void onClickApply(String sortById, String sortId, int startPoint, int endPoint);

    }

}
